{$FORM TForm2, Unit2.sfm}

uses
  Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Buttons, unMain, undm, DateUtils,
  IBQuery, IBDatabase, DB, SysUtils, Mask, Math, shellapi;

Var
   sheet,XLA : variant;
   f,filename1: string;
   sl,sl1: TStringList; //CSV
   NAC1,NAC2,NAC3,NAC_NAR : Float;


//    
Function CheckFiles (FileName:String):String;
begin
     result:=FileName;
     if FileExists(FileName) then
      begin
       if not DeleteFile(FileName) then
        begin
         frmmanagerxp2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'    : '+FileName);
         frmSpacePro.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+' : '+FileName+'   ,      ');
         ShowMessage(': '+DateToStr(Date)+' '+TimeToStr(Time)+' : '+FileName+'   ,      ');
        end;
      end;
end;

procedure CreateSheets;
begin

  XLA:=CreateOleObject('Excel.Application');

  XLA.Visible := false;
  XLA.DisplayAlerts := False;

  XLA.WorkBooks.Add;

  sheet:=XLA.WorkBooks[1].sheets.Add;
  sheet.Name := '';

  sheet.cells[1,1]:='';
  sheet.cells[1,2]:='';
  sheet.cells[1,3]:='';
  sheet.cells[1,4]:='';
  sheet.cells[1,5]:='';
  sheet.cells[1,6]:='';
  sheet.cells[1,7]:='';
  sheet.cells[1,8]:='';
end;


procedure CloseDocExcel;
begin
  f:=CheckFiles(E_path.Text);
  frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'     '+f+' ');

  XLA.ActiveWorkbook.SaveAs(f);
  XLA.Quit;
  XLA := Unassigned;
  if Check7.Checked then
   ShellExecute(Handle, 'open', 'Excel.exe', '"'+f+'"', nil, 1);
end;

function GetSQLValue(SQL:string): string;
var
  q : TTempQuery;
  db: TIbDatabase;
  t: string;
begin
   db:=dm.FindComponent('db');
   q:=dm.TempQuery(nil)
   q.Database:=db;
   q.active:=false;
   q.SQL.Text:=SQL;
   try
     q.active:=true;
     Result := Trim(q.FieldByName('pv').AsString);
   except
     frmManagerXP2.LogIt('! '+DateToStr(Date)+' '+TimeToStr(Time)+'    '+SQL+',    ');
     q.Transaction.Rollback;
     exit;
   end;
   q.free;
end;


procedure Form2Show(Sender: TObject);
begin
   //  
   filename1 := 'C:\Standart-N\'+'_'+DateToStr(Date)+'_'+StringReplace(TimeToStr(Time),':','',3)+'.txt';
   sl1:=TStringList.Create;
   sl1.Add(DateToStr(Date)+' '+TimeToStr(Time)+'    ');
   E_NAC_REGION.Text := GetSQLValue('select param_value as pv from PARAMS where param_id =''NAC_REGION'';');
   E_NAC1.text := GetSQLValue('select param_value as pv from PARAMS where param_id =''NAC1'';');
   E_NAC2.text := GetSQLValue('select param_value as pv from PARAMS where param_id =''NAC2'';');
   E_NAC3.text := GetSQLValue('select param_value as pv from PARAMS where param_id =''NAC3'';');
   E_NAC_NAR.text := GetSQLValue('select param_value as pv from PARAMS where param_id =''NAC4'';');
   NAC1 := StrToFloat(E_NAC1.text);
   NAC2 := StrToFloat(E_NAC2.text);
   NAC3 := StrToFloat(E_NAC3.text);
   NAC_NAR := StrToFloat(E_NAC_NAR.text);

   Sel_year.Text := IntToStr(YearOf(Date)-1);
   //E_path.Enabled := false;
   E_path.Text := 'C:\Standart-N\Import1.LS.xls'
   //Shape8.Visible := false;
   //Label5.Visible := false;
    ProgressBar1.Visible := false;
   Label7.Visible := false;
   Label6.Caption :=  '';
   N_GR_NAR.text := '47';
end;


procedure BitBtn1Click(Sender: TObject);
var
  q1 : TTempQuery;
  db: TIbDatabase;
  t, Log_s,pv,filename: string;
  index,error_rec,count_rec,maxvalue,i : integer;
  summa,summa_z,price_r,summa_o,quant,
  price,price_z,price_o,nac, max_price_r,koef1,koef2 : float;
  flag_rec : boolean;
begin
   if (Trim(Sel_year.Text)='') or (IntToStr(Trim(Sel_year.Text))<2016) then
    begin
     ShowMessage('        ,    .   !');
     frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'         ,    .   !');
     sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+'         ,    .   !');
     Exit;
    end;
   if Check8.Checked then
    begin
     if ProgressBar1.Visible then
       begin
       ProgressBar1.Position := 0;
       Label7.Caption :=  '0%';
       Label6.Caption :=  '';
      end
     else ProgressBar1.Visible := true;
    end;

   if (Trim(N_GR_NAR.text) = '') and (Check5.Checked) and (Trim(E_NAC_NAR.text) = '') then
    begin
     ShowMessage('      ,         .   !');
     frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'       ,         .   !');
     sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+'       ,         .   !');
     Exit;
    end;
   BitBtn1.Enabled := false;
   BitBtn2.Enabled := false;
   Label6.Caption :=  ' ...   ';
   koef1 := StrToFloat(StringReplace(Trim(MaskEdit1.Text),'_','',1));
   koef2 := StrToFloat(StringReplace(Trim(MaskEdit2.Text),'_','',1));
   Log_s := '';
   frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+' ********************* ');
   frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'      '+Trim(Sel_year.Text)+'.,  (01.01.'+Trim(Sel_year.Text)+' - 31.12.'+Trim(Sel_year.Text)+')');
   sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+'      '+Trim(Sel_year.Text)+'.,  (01.01.'+Trim(Sel_year.Text)+' - 31.12.'+Trim(Sel_year.Text)+')');
   if Check1.Checked then Log_s:= ' : ""'
   else Log_s := ' : ""'
   if Check2.Checked then Log_s:= Log_s+' '+' : ""'
   else Log_s:= Log_s+' '+' : ""'
   if not Check3.Checked then Log_s:= Log_s+' '+' : ""'
   else Log_s:= Log_s+' '+' : ""'
   if Check4.Checked then Log_s:= Log_s+' '+' : ""'
   else Log_s:= Log_s+' '+' : ""'
   if Check5.Checked then Log_s:= Log_s+' '+'    : ""    ='+Trim(N_GR_NAR.text)
   else Log_s:= Log_s+' '+'    : ""'
   frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+' '+Log_s);
   sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+' '+Log_s);
   if not Check2.Checked then
    begin
     ShowMessage('!   ,              ');
     frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+' !   ,              ');
     sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+' !   ,              ');
    end;
   db:=dm.FindComponent('db');
   q1:=dm.TempQuery(nil)
   q1.Database:=db;
   q1.active:=false;
   //   
   if Check5.Checked then
    t := 'select dd.sname, iif(coalesce(dd.price_r,0)=0,(select first 1 price_r from out$gnvls_barcode where barcode=dd.bcode_izg and date_reg<=''31.12.'+Trim(Sel_year.Text)+''' order by id desc),dd.price_r) as price_r,
       dd.bcode_izg,abs(sum(dd.summa_o)) as summao,abs(sum(dd.quant)) as quant, abs(sum(dd.price*dd.quant)) as summar,
       abs(sum(dd.price_z*dd.quant)) as summaz from vw_doc_detail dd
       join group_detail gd on gd.group_id='+Trim(N_GR_NAR.text)+' and gd.grouptable_id=dd.name_id  and gd.grouptable=''PARTS.NAME_ID''
       left join docs d on d.id=dd.doc_id where
       (dd.doc_commitdate between ''01.01.'+Trim(Sel_year.Text)+''' and ''31.12.'+Trim(Sel_year.Text)+''') and coalesce(trim(dd.bcode_izg),'''') <>''''
       and d.doc_type in(3,9)  and dd.price_z>0  group by dd.sname, dd.price_r, dd.bcode_izg having sum(dd.quant)<0;';
   else
    t := 'select dd.sname, iif(coalesce(dd.price_r,0)=0,(select first 1 price_r from out$gnvls_barcode where barcode=dd.bcode_izg and date_reg<=''31.12.'+Trim(Sel_year.Text)+''' order by id desc),dd.price_r) as price_r,
       dd.bcode_izg,abs(sum(dd.summa_o)) as summao, abs(sum(dd.quant)) as quant, abs(sum(dd.price*dd.quant)) as summar,
       abs(sum(dd.price_z*dd.quant)) as summaz from vw_doc_detail dd
       join group_detail gd on gd.group_id=1 and gd.grouptable_id=dd.name_id  and gd.grouptable=''PARTS.NAME_ID''
       left join docs d on d.id=dd.doc_id where
       (dd.doc_commitdate between ''01.01.'+Trim(Sel_year.Text)+''' and ''31.12.'+Trim(Sel_year.Text)+''') and coalesce(trim(dd.bcode_izg),'''') <>''''
       and d.doc_type in(3,9)  and dd.price_z>0  group by dd.sname, dd.price_r, dd.bcode_izg having sum(dd.quant)<0;';
   sl1.Add('    :');
   sl1.Add(t);
   q1.SQL.Text:=t;
   frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'  ...   ');
   try
     q1.active:=true;
   except
     frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'    '+t+',    ');
     sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+'    '+t+',    ');
     q1.Transaction.Rollback;
     exit;
   end;
   If (Q1.RecordCount)>0 then
    begin
     if Check8.Checked then
      begin
       frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'  ...     ');
       Label6.Caption :=  ' ...     ';
       q1.Last;
       count_rec :=q1.RecordCount;
       frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'     '+IntToStr(count_rec));
       sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+'     '+IntToStr(count_rec));
       q1.active:=false;
       Label6.Caption :=  ' ...   ';
       frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'  ...   ');
       q1.active:=true;
      end;
     index:=2;error_rec:= 0;i:=0;
     //  xls
     CreateSheets;
     //  
     filename := 'C:\Standart-N\ .txt';
     sl1.Add('   '+filename);
     sl:=TStringList.Create;
     sl.Add(';;;;;;;;');
     if Check8.Checked then
      Label7.Visible := true;
     while not q1.Eof do
      begin
       //    
       flag_rec := true;
       inc(i);
       if Check8.Checked then
        begin
         ProgressBar1.Position := (i * 100) div count_rec;
         Label7.Caption := IntToStr(((i * 100) div count_rec))+'%';
        end
       summa := q1.FieldByName('summar').AsFloat;
       summa_z := q1.FieldByName('summaz').AsFloat;
       summa_o := q1.FieldByName('summao').AsFloat;
       price_r := q1.FieldByName('price_r').AsFloat;
       quant := q1.FieldByName('quant').AsFloat;
       //if i=1069 then
        //frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  ');
       if flag_rec then
        if quant=0 then
         begin
          //frmManagerXP2.LogIt(IntToStr(i)+'   : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  ' );
          sl1.Add(IntToStr(i)+'   : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  ' );
          flag_rec := false;
         end;
       if flag_rec then
        if Trim(q1.FieldByName('bcode_izg').AsString)='' then
         begin
          frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+'    ,   = '+FloatToStr(quant));
          sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+'    ,   = '+FloatToStr(quant));
          flag_rec := false;
         end;
       if quant>10000 then
        frmManagerXP2.LogIt('  : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   = '+FloatToStr(quant) );
       if flag_rec then
        if price_r=0 then
         begin
          flag_rec := false;
          frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    = '+FloatToStr(price_r)+'   = '+FloatToStr(quant));
          sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    = '+FloatToStr(price_r)+'   = '+FloatToStr(quant));
         end;
       if flag_rec then
        if summa_z=0 then
         begin
          price_r := price_r*1.1;
          price_r := RoundTo(price_r,-6);
          frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+' summa_z='+FloatToStr(summa_z)+'     '+FloatToStr(price_r)+'   = '+FloatToStr(quant));
          sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+' summa_z='+FloatToStr(summa_z)+'     '+FloatToStr(price_r)+'   = '+FloatToStr(quant));
          summa_z := price_r*quant;
         end;
       if flag_rec then
        if summa=0 then
         begin
          flag_rec := false;
          frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    = '+FloatToStr(summa)+'   = '+FloatToStr(quant));
          sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    = '+FloatToStr(summa)+'   = '+FloatToStr(quant));
         end;
       if flag_rec then
        if summa_o=0 then
         begin
          flag_rec := false;
          frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    = '+FloatToStr(summa_o)+'   = '+FloatToStr(quant));
          sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    = '+FloatToStr(summa_o)+'   = '+FloatToStr(quant));
         end;
       if flag_rec then
        if (summa_o-summa)>0 then
         begin
          flag_rec := false;
          frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   '+FloatToStr(summa_o)+' >   '+FloatToStr(summa)+' !   = '+FloatToStr(quant));
          sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   '+FloatToStr(summa_o)+' >   '+FloatToStr(summa)+' !   = '+FloatToStr(quant));
         end;
       //    
       if Check3.Checked then
        begin
         price_z := RoundTo((summa_z/quant)/1.1,-6); // 
         price := RoundTo((summa/quant)/1.1,-6);     // 
         price_o := RoundTo((summa_o/quant)/1.1,-6); // 
        end
       //   
       else
        begin
         price_z := RoundTo((summa_z/quant)/1.1,-6);  // 
         price := RoundTo((summa/quant),-6);          // 
         price_o := RoundTo((summa_o/quant),-6);
        end;
       //    " "
       if Check2.Checked and flag_rec then
        begin
         //  
         //    
         if Check3.Checked then
          begin
           price_z := RoundTo((summa_z/quant)/1.1,-6); // 
           price := RoundTo((summa/quant)/1.1,-6);     // 
           price_o := RoundTo((summa_o/quant)/1.1,-6); // 
          end
         //   
         else
          begin
           price_z := RoundTo((summa_z/quant)/1.1,-6);  // 
           price := RoundTo((summa/quant),-6);          // 
           price_o := RoundTo((summa_o/quant),-6);
          end;
         //  
         if Check5.Checked then
          maxvalue:= NAC_NAR;
         else
          begin
           if price_z<=50 then maxvalue:=NAC1
           else
            begin
             if price_z>500 then maxvalue:=NAC3
             else maxvalue:=NAC2;
            end;
          end;
         if price_z>price_r then nac:=(price-price_o)*100/price_r
         else nac:=(price-price_o)*100/price_z;
         if (maxvalue - nac)<=0 then
          begin
           flag_rec := false;
           frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   '+FloatToStr(nac)+' -   '+FloatToStr(maxvalue)+',   '+FloatToStr(price_z)+',    = '+FloatToStr(quant));
           sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   '+FloatToStr(nac)+' -   '+FloatToStr(maxvalue)+',   '+FloatToStr(price_z)+',    = '+FloatToStr(quant));
          end;

         //    -  ,    2    
         //    
         if Check3.Checked then //        
          If ((price_z/2)-price_o>0) then
           begin
            if flag_rec then
             begin
              flag_rec := false;
              frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    '+FloatToStr(price_o)+' -  ,    2     '+FloatToStr(price_z)+',    = '+FloatToStr(quant));
              sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'    '+FloatToStr(price_o)+' -  ,    2     '+FloatToStr(price_z)+',    = '+FloatToStr(quant));
             end;
           end
         //   ,  ,    2     
         pv := GetSQLValue('select first 1 price as pv from OUT$GNVLS_BARCODE where BARCODE ='''+Trim(q1.FieldByName('bcode_izg').AsString)+''' and date_reg<=''31.12.'+Trim(Sel_year.Text)+''' order by id desc');
         If pv = '' then max_price_r := 0.00
         else max_price_r := RoundTo(StrToFloat(pv),-6);
         if max_price_r >0 then
          begin
           //   "   .  "
           if Check6.Checked then
            if ((max_price_r/2)-price)>0 then
             begin
              if flag_rec then
               begin
                flag_rec := false;
                frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  . '+FloatToStr(price)+',  ,    2      '+FloatToStr(max_price_r)+',    = '+FloatToStr(quant));
                sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  . '+FloatToStr(price)+',  ,    2      '+FloatToStr(max_price_r)+',    = '+FloatToStr(quant));
               end;
             end;
           if flag_rec then
            if (price>=max_price_r) then
             begin
              flag_rec := false;
              frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  . '+FloatToStr(price)+',  ,     '+FloatToStr(max_price_r)+',    = '+FloatToStr(quant));
              sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  . '+FloatToStr(price)+',  ,     '+FloatToStr(max_price_r)+',    = '+FloatToStr(quant));
             end;
          end
         else
          begin
           pv := GetSQLValue('select first 1 price as pv from OUT$GNVLS_BARCODE where BARCODE ='''+Trim(q1.FieldByName('bcode_izg').AsString)+''' and date_reg>''31.12.'+Trim(Sel_year.Text)+''' order by id desc');
           if pv <> '' then
            begin
             frmManagerXP2.LogIt(IntToStr(i)+'    : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   , !   = '+FloatToStr(quant));
             sl1.Add(IntToStr(i)+'    : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   , !   = '+FloatToStr(quant));
             flag_rec := false;
            end
           else
            begin
             frmManagerXP2.LogIt(IntToStr(i)+'    : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'       !   = '+FloatToStr(quant));
             sl1.Add(IntToStr(i)+'    : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'       !   = '+FloatToStr(quant));
             flag_rec := false;
            end;
          end;
        end;
       //    " :  . <  "
       if Check4.Checked and flag_rec then
        begin
         if (price<price_z) then
          begin
           flag_rec := false;
           frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'      " :  . '+FloatToStr(price)+' <   '+FloatToStr(price_z)+'",      = '+FloatToStr(quant));
           sl1.Add(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'      " :  . '+FloatToStr(price)+' <   '+FloatToStr(price_z)+'",      = '+FloatToStr(quant));
          end;
        end;
       //       
       if flag_rec then
        begin
         //frmManagerXP2.LogIt(IntToStr(i)+' : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'   ');
         Sheet.cells[index,1]:=Trim(q1.FieldByName('bcode_izg').AsString);
         if quant*koef1>10000 then
          frmManagerXP2.LogIt('  : '+Trim(q1.FieldByName('sname').AsString)+' '+Trim(q1.FieldByName('bcode_izg').AsString)+'  / = '+FloatToStr(quant)+' / '+FloatToStr(koef1));
         Sheet.cells[index,2]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((quant*koef1),-6)/1000])),',','.',1);
         //    
         if Check3.Checked then
          begin
           Sheet.cells[index,3]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((((price_o*quant)/1.1)*koef1),-6)/1000])),',','.',1);
           Sheet.cells[index,4]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((((price*quant)/1.1)*koef1),-6)/1000])),',','.',1);
           Sheet.cells[index,5]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((((price_z*quant)/1.1)*koef1),-6)/1000])),',','.',1);
           Sheet.cells[index,8]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((((((price*quant)/1.1)*koef1)-(((price_o*quant)/1.1)*koef1))*koef2),-6)/1000])),',','.',1);

           sl.Add(Trim(q1.FieldByName('bcode_izg').AsString)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(quant*koef1,-6)])),',','.',1)+';'+
           StringReplace(FloatToStr(Format('%.6f',[RoundTo(((price_o*quant)/1.1)*koef1,-6)])),',','.',1)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(((price*quant)/1.1)*koef1,-6)])),',','.',1)+';'+
           //StringReplace(FloatToStr(Format('%.6f',[price_z])),',','.',1)+'; ;'+
           StringReplace(FloatToStr(Format('%.6f',[RoundTo(((price_z*quant)/1.1)*koef1,-6)])),',','.',1)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(price_r,-6)])),',','.',1)+';'+
           StringReplace(FloatToStr(Format('%.6f',[RoundTo(quant*koef2,-6)])),',','.',1)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(((((price*quant)/1.1)*koef1)-(((price_o*quant)/1.1)*koef1))*koef2,-6)])),',','.',1)+';');
          end
         else
          begin
           Sheet.cells[index,3]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((price_o*quant*koef1),-6)/1000])),',','.',1);
           Sheet.cells[index,4]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((price*quant*koef1),-6)/1000])),',','.',1);
           Sheet.cells[index,5]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((price_z*quant*koef1),-6)/1000])),',','.',1);
           Sheet.cells[index,8]:=StringReplace(FloatToStr(Format('%.6f',[RoundTo((((price*quant*koef1)-(price_o*quant*koef1))*koef2),-6)/1000])),',','.',1);

           sl.Add(Trim(q1.FieldByName('bcode_izg').AsString)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(quant*koef1,-6)])),',','.',1)+';'+
           StringReplace(FloatToStr(Format('%.6f',[RoundTo(price_o*quant*koef1,-6)])),',','.',1)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(price*quant*koef1,-6)])),',','.',1)+';'+
           //StringReplace(FloatToStr(Format('%.6f',[price_z])),',','.',1)+'; ;'+
           StringReplace(FloatToStr(Format('%.6f',[RoundTo(price_z*quant*koef1,-6)])),',','.',1)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(price_r,-6)])),',','.',1)+';'+
           StringReplace(FloatToStr(Format('%.6f',[RoundTo(quant*koef2,-6)])),',','.',1)+';'+StringReplace(FloatToStr(Format('%.6f',[RoundTo(((price*quant*koef1)-(price_o*quant*koef1))*koef2,-6)])),',','.',1)+';');
          end;
         //Sheet.cells[index,6]:='';
         Sheet.cells[index,6]:=StringReplace(FloatToStr(Format('%.6f',[price_r])),',','.',1);
         Sheet.cells[index,7]:=StringReplace(FloatToStr(Format('%.6f',[(quant*koef2)/1000])),',','.',1);

         inc(index);
        end
       if not flag_rec then inc(error_rec);
       q1.Next;
      end;
     //CSV
     if FileExists(filename) then
      begin
       if not DeleteFile(filename) then
        begin
         frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'    : '+filename);
         frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+' : '+filename+'   ,      ');
         ShowMessage(': '+DateToStr(Date)+' '+TimeToStr(Time)+' : '+filename+'   ,      ');
         sl.Free;
         exit;
        end;
      end;
     if FileExists(filename1) then
      begin
       if not DeleteFile(filename1) then
        begin
         frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'    : '+filename1);
         frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+' : '+filename1+'   ,      ');
         ShowMessage(': '+DateToStr(Date)+' '+TimeToStr(Time)+' : '+filename1+'   ,      ');
         sl1.Free;
         exit;
        end;
      end;
     frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'     '+filename);
     sl.SaveToFile(filename);
     sl.Free;
     sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+'     '+filename);
     //end csv
     BitBtn1.Enabled := true;
     BitBtn2.Enabled := true;
     frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'   '+IntToStr(i)+' (),         '+IntToStr(error_rec)+' ()');
     sl1.Add(': '+DateToStr(Date)+' '+TimeToStr(Time)+'   '+IntToStr(i)+' (),         '+IntToStr(error_rec)+' ()');
     ProgressBar1.Position :=0;
     Label6.Caption := ' ';
     //      
     CloseDocExcel;
     ShowMessage('  '+IntToStr(i)+' (),         '+IntToStr(error_rec)+' ()');
     sl1.Add(' ');
    end
   else
    begin
     ShowMessage('   "'+Trim(Sel_year.Text)+'"        ,    .   !');
     frmManagerXP2.LogIt(': '+DateToStr(Date)+' '+TimeToStr(Time)+'    "'+Trim(Sel_year.Text)+'"        ,    .   !');
     Exit;
    end;
   q1.free;
   sl1.SaveToFile(filename1);
   sl1.Free;
end;

procedure BitBtn2Click(Sender: TObject);
begin
  close;
end;

procedure Check5MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if Check5.Checked then
    begin
     E_NAC_NAR.Visible := true;
     N_GR_NAR.Visible := true;
     Label9.Visible := true;
     Label10.Visible := true;
    end
  else
   begin
    E_NAC_NAR.Visible := false;
    N_GR_NAR.Visible := false;
    Label9.Visible := false;
    Label10.Visible := false;
   end;
end;


begin

end;
